diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/misc.c tin-2.6.5/src/misc.c
--- tin-2.6.4/src/misc.c	2024-12-22 18:22:28.000000000 +0100
+++ tin-2.6.5/src/misc.c	2025-12-20 18:11:31.243627963 +0100
@@ -4930,8 +4979,45 @@ make_connection_page(
 	fprintf(fp, "\n");
 	fprintf(fp, ".newsrc            : %s\n", newsrc);
 
-	if (tinrc.cache_overview_files)
-		fprintf(fp, "local overviews    : %s\n", index_newsdir);
+	/*
+	 * "-$NNTPSERVER" is appended in find_nov_file()
+	 * which may not haven been called yet (e.g. not
+	 * entered a group till now), so index_newsdir may
+	 * lack the suffix, fix it for displaying only
+	 */
+	if (serverrc.cache_overview_files) {
+		char *ns = strcasestr(index_newsdir, nntp_server);
+		char *idx_nd = my_strdup(index_newsdir);
+
+		if (!ns || strlen(ns) != strlen(nntp_server)) {
+			char *srv = my_strdup(nntp_server);
+
+			idx_nd = append_to_string(idx_nd, "-");
+			idx_nd = append_to_string(idx_nd, srv);
+			free(srv);
+		}
+		add_slash = (idx_nd[strlen(idx_nd) - 1] != '/');
+
+#ifdef USE_ZLIB
+		fprintf(fp, "local overviews %s: %s%s\n", serverrc.compress_overview_files ? "[c]" : "   ", idx_nd, add_slash ? "/" : "");
+#else
+		fprintf(fp, "local overviews    : %s%s\n", idx_nd, add_slash ? "/" : "");
+#endif /* USE_ZLIB */
+		free(idx_nd);
+	}
+
+#ifdef DEBUG
+	{	/*
+		 * till we have a serverrc-menu
+		 * the user likely remembers what he just gave
+		 * on the cmd.-line so we omit that here
+		 */
+		const char *e = get_val("TINRC", NULL);
+
+		if (strlen(BlankIfNull(e)) + strlen(BlankIfNull(serverrc.add_cmd_line_opts)))
+			fprintf(fp, "\n\'$TINRC\' \'serverrc\': \'%s\' \'%s\'\n", BlankIfNull(e), BlankIfNull(serverrc.add_cmd_line_opts));
+	}
+#endif /* DEBUG */
 }
 
 
@@ -4971,7 +5057,7 @@ srndm(
 	time_t t;
 
 	if ((t = time(NULL)) == (time_t) -1)
-		t = (time_t) getpid();
+		t = (time_t) process_id;
 	else {
 		if (t >= 1041379200) /* 2003-01-01 00:00:00 GMT */
 			t -= 1041379200;
@@ -4992,7 +5078,7 @@ srndm(
 /*
  * opens pathname with mode if it is S_IFREG or S_IFLNK
  * if mode is "r[b]" (read only) its size needs to be > 0L
- * returns FILE* on success or NULL on failure
+ * returns FILE * on success or NULL on failure
  * if NULL is returned and errno is 0, it either had a zero size
  * or was neither S_IFDIR, S_IFLNK or S_IFREG.
  *
@@ -5017,7 +5103,7 @@ tin_fopen(
 			if (S_ISDIR(st.st_mode))
 				serrno = errno = EISDIR;
 			else {
-				if (st.st_mode & (S_IFREG | S_IFLNK)) {
+				if (S_ISREG(st.st_mode)) {
 					if (mode[0] == 'r' && (mode[1] == '\0' || (mode[1] == 'b' && mode[2] == '\0')) && st.st_size <= 0L) {
 #ifdef DEBUG
 						if (debug & DEBUG_MISC)
@@ -5054,12 +5140,12 @@ out:
 		case EISDIR:
 			/*
 			 * TODO: issue an error message here
-			 *       this requires some rework elsewhere in the
-			 *       code, i.e. "-f /tmp/isdir" would
+			 *       this requires some rework elsewhere in
+			 *       the code, i.e. "-f /tmp/isdir" would
 			 *       lead to multiple messages, most of them
-			 *       may confuse the user. at least
-			 *       put the  _(txt_reading_* message
-			 *       before the tin_fopen call.
+			 *       may confuse the user. at least put the
+			 *       _(txt_reading_*) message before the
+			 *       tin_fopen() call.
 			 */
 #ifdef DEBUG
 			if (debug & DEBUG_MISC)
@@ -5124,7 +5210,7 @@ tin_ucnv_buffer_to_local(
 	unicode_buffer = my_calloc(ilen, sizeof(UChar));
 
 	p = *line;
-	while ((p = strchr(p, '?')) != NULL) { /* count input questionmarks */
+	while ((p = strchr(p, '?')) != NULL) { /* TODO: fixme, instead of counting output questionmarks use ucnv_setToUCallBack(...,UCNV_TO_U_CALLBACK_SUBSTITUTE,...) */
 		--quest;
 		++p;
 	}
@@ -5166,7 +5252,7 @@ tin_ucnv_buffer_to_local(
 	} while (err == U_BUFFER_OVERFLOW_ERROR);
 
 	p = output_buffer;
-	while ((p = strchr(p, '?')) != NULL) { /* count output questionmarks */
+	while ((p = strchr(p, '?')) != NULL) { /* TODO: fixme, instead of counting output questionmarks use ucnv_setFromUCallBack(..,UCNV_FROM_U_CALLBACK_SUBSTITUTE,..) */
 		++quest;
 		++p;
 	}
@@ -5184,7 +5270,7 @@ tin_ucnv_buffer_to_local(
 
 	/* copy result */
 	free(*line);
-	*line = strdup(output_buffer);
+	*line = my_strdup(output_buffer);
 	*max_line_len = strlen(output_buffer);
 
 	/* cleanup */
@@ -5196,3 +5282,70 @@ tin_ucnv_buffer_to_local(
 }
 #	endif /* CHARSET_CONVERSION_UCNV */
 #endif /* CHARSET_CONVERSION */
+
+
+int
+sync_close(
+	int fd)
+{
+	int rc;
+
+#ifdef HAVE_FSYNC
+#	ifdef EINTR
+fsync_again:
+#	endif /*EINTR */
+	if ((rc = fsync(fd)) < 0) {
+		int serrno;
+
+#	ifdef EINTR
+		if (errno == EINTR)
+			goto fsync_again;
+#	endif /* !EINTR */
+
+		serrno = errno;
+#	ifdef HAVE_POSIX_CLOSE
+		posix_close(fd, 0);
+#	else
+		close(fd);
+#	endif /* HAVE_POSIX_CLOSE */
+		errno = serrno;
+		return rc;
+	}
+#endif /* HAVE_FSYNC */
+
+#ifdef EINTR
+close_again:
+#endif /* EINTR */
+	rc = close(fd);
+#ifdef EINTR
+	if (rc < 0 && errno == EINTR) {
+		struct stat st;
+
+		if (fstat(fd, &st) == 0) /* fd still open? */
+			goto close_again;
+	}
+#endif /* EINTR */
+
+	return rc;
+}
+
+
+const char *
+logtime(
+	void)
+{
+#if defined(HAVE_CLOCK_GETTIME) || defined(HAVE_GETTIMEOFDAY)
+	static struct t_tintime log_time;
+	static char out[40];
+
+	if (tin_gettime(&log_time) == 0) {
+		if (my_strftime(out, 39, " [%H:%M:%S.", gmtime(&(log_time.tv_sec)))) {
+			snprintf(out + 11, sizeof(out) - 11, "%09ld", log_time.tv_nsec); /* strlen(" [hh:mm:ss.") */
+			out[17] = '\0'; /* strlen(" [hh:mm:ss.uuuuuu") */
+			strcat(out, "] ");
+			return out;
+		}
+	}
+#endif /* HAVE_CLOCK_GETTIME || HAVE_GETTIMEOFDAY */
+	return " ";
+}
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/my_tmpfile.c tin-2.6.5/src/my_tmpfile.c
--- tin-2.6.4/src/my_tmpfile.c	2024-12-03 09:07:04.000000000 +0100
+++ tin-2.6.5/src/my_tmpfile.c	2025-12-06 18:42:01.434419224 +0100
@@ -3,10 +3,10 @@
  *  Module    : my_tmpfile.c
  *  Author    : Urs Janssen <urs@tin.org>
  *  Created   : 2001-03-11
- *  Updated   : 2024-12-03
+ *  Updated   : 2024-12-06
  *  Notes     :
  *
- * Copyright (c) 2001-2025 Urs Janssen <urs@tin.org>
+ * Copyright (c) 2001-2026 Urs Janssen <urs@tin.org>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -79,16 +79,18 @@ my_mktmp(
 
 		if (base_dir) {
 #ifdef HAVE_LONG_FILE_NAMES
+			const char *nodenamebuf = BlankIfNull(get_host_name());
+
 			/*
 			 * base_dir may reside on a shared network device
 			 * so add hostname/pid if allowed.
 			 */
-			if ((n = snprintf(NULL, 0, "tin-%s-%ld-XXXXXX", get_host_name(), (long) process_id)) < 0)
+			if ((n = snprintf(NULL, 0, "tin-%s-%ld-XXXXXX", nodenamebuf, (long) process_id)) < 0)
 				goto error_out;
 
 			len = (size_t) n + 1;
 			buf = my_malloc(len);
-			if (snprintf(buf, len, "tin-%s-%ld-XXXXXX", get_host_name(), (long) process_id) != n) {
+			if (snprintf(buf, len, "tin-%s-%ld-XXXXXX", nodenamebuf, (long) process_id) != n) {
 				free(buf);
 				goto error_out;
 			}
@@ -111,7 +113,7 @@ my_mktmp(
 			 */
 			if ((n = snprintf(NULL, 0, "tin_XXXXXX")) < 0) {
 #ifdef DEBUG
-wait_message(5, "snprintf(NULL, 0, \"tin_XXXXXX\")=%d", n);
+				wait_message(5, "snprintf(NULL, 0, \"tin_XXXXXX\")=%d", n);
 #endif /* DEBUG */
 				goto error_out;
 			}
@@ -120,7 +122,7 @@ wait_message(5, "snprintf(NULL, 0, \"tin
 			buf = my_malloc(len);
 			if (snprintf(buf, len, "tin_XXXXXX") != n) {
 #ifdef DEBUG
-wait_message(5, "snprintf(%s, %d, \"tin_XXXXXX\")=%d", BlankIfNull(buf), len, n);
+				wait_message(5, "snprintf(%s, %d, \"tin_XXXXXX\")=%d", BlankIfNull(buf), len, n);
 #endif /* DEBUG */
 				free(buf);
 				goto error_out;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/newsrc.c tin-2.6.5/src/newsrc.c
--- tin-2.6.4/src/newsrc.c	2024-12-09 15:15:30.000000000 +0100
+++ tin-2.6.5/src/newsrc.c	2025-12-09 10:19:02.845108421 +0100
@@ -3,10 +3,10 @@
  *  Module    : newsrc.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-09
+ *  Updated   : 2025-12-09
  *  Notes     : ArtCount = (ArtMax - ArtMin) + 1  [could have holes]
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -60,7 +60,7 @@
  * Local prototypes
  */
 static FILE *open_subscription_fp(void);
-static char *parse_newsrc_line(char *line, int *sub);
+static char *parse_newsrc_line(const char *line, int *sub);
 static char *parse_subseq(struct t_group *group, char *seq, t_artnum *low, t_artnum *high, t_artnum *sum);
 static char *parse_get_seq(char *seq, t_artnum *low, t_artnum *high);
 static int write_newsrc_line(FILE *fp, char *line);
@@ -90,7 +90,7 @@ read_newsrc(
 	FILE *fp;
 	char *grp, *seq;
 	int sub, i;
-	signed long line_count = 0;
+	signed long line_count = 0L;
 	struct stat statbuf;
 
 	if (allgroups)
@@ -359,19 +359,24 @@ static FILE *
 open_subscription_fp(
 	void)
 {
-	if (!read_saved_news) {
+	if (read_saved_news)
+		return (FILE *) 0;
+	else {
 #ifdef NNTP_ABLE
 		if (read_news_via_nntp) {
 			/* RFC 6048 2.6 */
-			if (nntp_caps.type == CAPABILITIES && !nntp_caps.list_subscriptions)
-				return NULL;
+			if (!nntp_caps.list_subscriptions)
+				return (FILE *) 0;
 			else
 				return (nntp_command("LIST SUBSCRIPTIONS", OK_GROUPS, NULL, 0));
-		} else
+		}
 #endif /* NNTP_ABLE */
-			return (fopen(subscriptions_file, "r"));
-	} else
-		return NULL;
+#ifndef NNTP_ONLY
+		return (fopen(subscriptions_file, "r"));
+#else
+		return (FILE *) 0;
+#endif /* !NNTP_ONLY */
+	}
 }
 
 
@@ -448,26 +453,124 @@ backup_newsrc(
 	char dirbuf[PATH_LEN];
 	char filebuf[PATH_LEN];
 	struct stat statbuf;
+	FILE *fp_in, *fp_out;
 
-#ifdef NNTP_ABLE
-	if (read_news_via_nntp && !read_saved_news && nntp_tcp_port != IPPORT_NNTP)
-		snprintf(filebuf, sizeof(filebuf), "%s:%u", nntp_server, nntp_tcp_port);
-	else
-#endif /* NNTP_ABLE */
-	{
-		STRCPY(filebuf, quote_space_to_dash(nntp_server));
-	}
+	STRCPY(filebuf, quote_space_to_dash(nntp_server));
 	joinpath(dirbuf, sizeof(dirbuf), rcdir, filebuf);
 	joinpath(filebuf, sizeof(filebuf), dirbuf, OLDNEWSRC_FILE);
 
 	if (stat(dirbuf, &statbuf) == -1) {
 		if (my_mkdir(dirbuf, (mode_t) (S_IRWXU)) == -1)
-			/* Can't create directory: Fall back on Homedir */
+			/* Can't create directory: Fall back to homedir */
 			joinpath(filebuf, sizeof(filebuf), homedir, OLDNEWSRC_FILE);
 	}
 
+#if defined(HAVE_REALPATH) && (defined(O_NOFOLLOW) || defined(HAVE_LSTAT))
+	/*
+	 * preserve symlink if target is below homedir (dedian bug #151113)
+	 *
+	 * requires realpath(3) as readlink(3) doesn't canonicalize;
+	 * prefer the O_NOFOLLOW path as that avoids TOCTOU
+	 *
+	 * TODO: return errno
+	 */
+	{
+		t_bool islink = FALSE;
+#	ifdef O_NOFOLLOW
+		int fd;
+#	endif /* O_NOFOLLOW */
+
+		if ((fp_in = tin_fopen(newsrc, "r")) == NULL)
+			return;
+
+#	ifdef O_NOFOLLOW
+		if ((fd = open(filebuf, (O_RDWR|O_CREAT|O_APPEND|O_NOFOLLOW), (S_IRUSR|S_IWUSR))) == -1) {
+			if ((fd = open(filebuf, (O_RDWR|O_CREAT|O_APPEND), (S_IRUSR|S_IWUSR))) == -1) {
+				fclose(fp_in);
+				perror_message(_(txt_cannot_open), filebuf);
+				return;
+			}
+			islink = TRUE;
+		}
+
+		if ((fp_out = fdopen(fd, "a+")) == NULL) {
+#		ifdef HAVE_POSIX_CLOSE
+			posix_close(fd, 0);
+#		else
+			close(fd);
+#		endif /* HAVE_POSIX_CLOSE */
+			fclose(fp_in);
+			perror_message(_(txt_cannot_open), filebuf);
+			return;
+		}
+#	else
+		/* TOCTOU */
+		if ((fp_out = fopen(filebuf, "a+")) == NULL) {
+			fclose(fp_in);
+			perror_message(_(txt_cannot_open), filebuf);
+			return;
+		}
+
+		if (lstat(filebuf, &statbuf) != 0) {
+			fclose(fp_in);
+			fclose(fp_out);
+			perror_message(_(txt_cannot_open), filebuf);
+			return;
+		}
+
+		if (S_ISLNK(statbuf.st_mode))
+			islink = TRUE;
+
+#	endif /* O_NOFOLLOW */
+
+		if (islink) {
+			char target[PATH_LEN] = { '\0' };
+
+			if (realpath(filebuf, target) == NULL) {
+				fclose(fp_in);
+				fclose(fp_out);
+				return;
+			} else {
+				joinpath(dirbuf, sizeof(dirbuf), homedir, ""); /* ensure homedir is '/'-terminated */
+
+				if (strncmp(dirbuf, target, strlen(dirbuf))) { /* disallow symlinks outside homedir */
+#		ifdef DEBUG
+					if (debug & DEBUG_NEWSRC) {
+						char *debug_mesg;
+						int n;
+
+						if ((n = snprintf(NULL, 0, "overwriting %s-link \"%s\", target \"%s\" not below \"%s\"", OLDNEWSRC_FILE, filebuf, target, dirbuf)) > 0) {
+							if (n < INT_MAX) {
+								debug_mesg = my_malloc(++n);
+								snprintf(debug_mesg, n, "overwriting %s-link \"%s\", target \"%s\" not below \"%s\"", OLDNEWSRC_FILE, filebuf, target, dirbuf);
+								debug_print_comment(debug_mesg);
+								error_message(2, "Warning: %s", debug_mesg);
+								free(debug_mesg);
+							}
+						}
+					}
+#		endif /* DEBUG */
+					fclose(fp_in);
+					fclose(fp_out);
+					if (!backup_file(newsrc, filebuf))
+						error_message(2, _(txt_filesystem_full_backup), newsrc);
+					return;
+				}
+			}
+		}
+
+		if (ftruncate(fileno(fp_out), 0L) == 0)
+			copy_fp(fp_in, fp_out);
+
+		fclose(fp_in);
+		fclose(fp_out);
+	}
+#else
 	if (!backup_file(newsrc, filebuf))
 		error_message(2, _(txt_filesystem_full_backup), newsrc);
+#endif /* HAVE_REALPATH && (O_NOFOLLOW || HAVE_LSTAT) */
+
+	return;
 }
 
 
@@ -490,6 +593,7 @@ group_get_art_info(
 	if (read_news_via_nntp && grouptype == GROUP_TYPE_NEWS) {
 #ifdef NNTP_ABLE
 		char line[NNTP_STRLEN];
+		int respcode;
 
 		snprintf(line, sizeof(line), "GROUP %s", groupname);
 #	ifdef DEBUG
@@ -497,8 +601,9 @@ group_get_art_info(
 			debug_print_file("NNTP", "group_get_art_info %s", line);
 #	endif /* DEBUG */
 		put_server(line, FALSE);
+		respcode = get_respcode(line, sizeof(line));
 
-		switch (get_respcode(line, sizeof(line))) {
+		switch (respcode) {
 			case OK_GROUP:
 				if (sscanf(line, "%"T_ARTNUM_SFMT" %"T_ARTNUM_SFMT" %"T_ARTNUM_SFMT, art_count, art_min, art_max) != 3) {
 #	ifdef DEBUG
@@ -515,7 +620,7 @@ group_get_art_info(
 				return -ERR_NOGROUP;
 
 			case ERR_ACCESS:
-				tin_done(NNTP_ERROR_EXIT, "%s", line);
+				tin_done(NNTP_ERROR_EXIT, "%d %s (%s)", respcode, line, groupname);
 				/* keep lint quiet: */
 				/* NOTREACHED */
 				break;
@@ -996,7 +1101,7 @@ parse_bitmap_seq(
 	if (debug & DEBUG_NEWSRC) {
 		char buf[NEWSRC_LINE];
 
-		snprintf(buf, sizeof(buf), "Parsing [%s%c %.*s]", group->name, SUB_CHAR(group->subscribed), (int) (NEWSRC_LINE - strlen(group->name) - 14), BlankIfNull(ptr));
+		snprintf(buf, sizeof(buf), "\nParsing [%s%c %.*s]", group->name, SUB_CHAR(group->subscribed), (int) (NEWSRC_LINE - strlen(group->name) - 14), BlankIfNull(ptr));
 		debug_print_comment(buf);
 		debug_print_bitmap(group, NULL);
 	}
@@ -1577,6 +1682,10 @@ catchup_newsrc_file(
 {
 	int i;
 	struct t_group *group;
+	time_t beg_epoch = 0;
+
+	if (verbose)
+		(void) time(&beg_epoch);
 
 	for (i = 0; i < selmenu.max; i++) {
 		group = &active[my_group[i]];
@@ -1588,6 +1697,41 @@ catchup_newsrc_file(
 		group->newsrc.num_unread = 0;
 		group->newsrc.xbitlen = 0;
 	}
+	if (verbose) {
+		const char *action_fmt = P_(txt_catchup_info_sp[0], txt_catchup_info_sp[1], i);
+		const char *elapsed_fmt;
+		char *action;
+		char *elapsed;
+		int n;
+		size_t len;
+		time_t tela = (unsigned long int) (time(NULL) - beg_epoch);
+
+		if ((n = snprintf(NULL, 0, action_fmt, i)) < 0)
+			return;
+		len = (size_t) n + 1;
+		action = my_malloc(len);
+		if (snprintf(action, len, action_fmt, i) < 0) {
+			free(action);
+			return;
+		}
+
+		elapsed_fmt = P_(txt_n_second_sp[0], txt_n_second_sp[1], tela);
+		if ((n = snprintf(NULL, 0, elapsed_fmt, tela)) < 0) {
+			free(action);
+			return;
+		}
+		len = (size_t) n + 1;
+		elapsed = my_malloc(len);
+		if (snprintf(elapsed, len, elapsed_fmt, tela) < 0) {
+			free(action);
+			free(elapsed);
+			return;
+		}
+
+		wait_message(0, _(txt_catchup_update_info), action, elapsed);
+		free(action);
+		free(elapsed);
+	}
 }
 
 
@@ -1598,7 +1742,7 @@ catchup_newsrc_file(
  */
 static char *
 parse_newsrc_line(
-	char *line,
+	const char *line,
 	int *sub)
 {
 	char *ptr, *tmp;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/nntplib.c tin-2.6.5/src/nntplib.c
--- tin-2.6.4/src/nntplib.c	2024-12-21 02:56:55.000000000 +0100
+++ tin-2.6.5/src/nntplib.c	2025-12-18 19:40:47.309138047 +0100
@@ -3,7 +3,7 @@
  *  Module    : nntplib.c
  *  Author    : S. Barber & I. Lea
  *  Created   : 1991-01-12
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-18
  *  Notes     : NNTP client routines taken from clientlib.c 1.5.11 (1991-02-10)
  *  Copyright : (c) Copyright 1991-99 by Stan Barber & Iain Lea
  *              Permission is hereby granted to copy, reproduce, redistribute
@@ -25,6 +25,49 @@
 #	include "tnntp.h"
 #endif /* !TNNTP_H */
 
+#ifdef HAVE_NETINET_TCP_H
+#	include <netinet/tcp.h>
+#endif /* HAVE_NETINET_TCP_H */
+#if defined(NNTP_ABLE) && defined(HAVE_GETSOCKOPT) && defined(HAVE_SETSOCKOPT)
+	/* avoid SO_RCVTIMEO due to delayed responses when COMPRESS is used */
+#	ifdef TCP_USER_TIMEOUT /* Linux >= 2.6.37 */
+#		define TIMEOUT_TYPE	unsigned int
+#		define TIMEOUT_DIV 1
+#		define TIMEOUT_MUL 1000
+#		define TIMEOUT_INI_NAME TCP_USER_TIMEOUT
+#		define TIMEOUT_RXT_NAME TCP_USER_TIMEOUT
+#	else
+#		ifdef TCP_RXT_CONNDROPTIME /* Mac OS X > 10.6 */
+#			define TIMEOUT_TYPE int
+#			define TIMEOUT_DIV 1000
+#			define TIMEOUT_MUL 1
+#			define TIMEOUT_INI_NAME TCP_CONNECTIONTIMEOUT
+#			define TIMEOUT_RXT_NAME TCP_RXT_CONNDROPTIME
+/*
+ * no (well) tested, so disabled for now and stick with alarm()
+ * - __OpenBSD__  7.6: not available
+ * - __FreeBSD__ 15.0: looks ok
+ * - __NetBSD__    10: times out too early
+ * - __DragonFly__   : not tested
+ * - __MidnightBSD__ : not tested
+ * - __sun           : not tested
+ * - _AIX            : not tested
+ * - ...
+ */
+/*
+#		else
+#			ifdef TCP_KEEPINIT
+#				define TIMEOUT_TYPE int
+#				define TIMEOUT_INI_NAME TCP_KEEPINIT
+#				define TIMEOUT_MUL 1
+#				undef TIMEOUT_RXT_NAME
+#				undef TIMEOUT_DIV
+#			endif
+*/
+#		endif /* TCP_RXT_CONNDROPTIME */
+#	endif /* TCP_USER_TIMEOUT */
+#endif /* NNTP_ABLE && HAVE_GETSOCKOPT && HAVE_SETSOCKOPT */
+
 #ifdef USE_ZLIB
 #	include <zlib.h>
 #endif /* USE_ZLIB */
@@ -58,8 +101,13 @@ char *nntp_server = NULL;
 #ifdef NNTP_ABLE
 	static int mode_reader(t_bool *sec);
 	static int reconnect(int retry);
-	static int server_init(char *machine, const char *cservice, unsigned short port, char *text, size_t mlen);
+	static int server_init(const char *machine, const char *cservice, unsigned short port, char *text, size_t mlen);
 	static void close_server(t_bool send_no_quit);
+	static t_distrib_pat *add_distrib_pat(int weight, const char *pat, const char *dist, const char *desc);
+	static void list_distrib_pats(void);
+	static void list_distributions(void);
+	static long set_tcp_user_ini_timeout(int sockfd, t_bool set);
+	static long set_tcp_user_rxt_timeout(int sockfd, t_bool set);
 	static long int list_motd(FILE *stream);
 #	ifdef INET6
 		static int get_tcp6_socket(const char *machine, unsigned short port);
@@ -81,16 +129,16 @@ char *nntp_server = NULL;
 		struct simplebuf rd;
 		struct simplebuf wr;
 		int fd;
-#	ifdef HAVE_GETPEERNAME
+#	if defined(HAVE_GETSOCKOPT) || defined(HAVE_GETPEERNAME)
 		sa_family_t family;
 #	else
 		int family;
-#	endif /* HAVE_GETPEERNAME */
+#	endif /* HAVE_GETSOCKOPT || HAVE_GETPEERNAME */
 #	ifdef USE_ZLIB
 		z_streamp z_wr;
 		z_streamp z_rd;
-		unsigned char* z_wr_buf;
-		unsigned char* z_rd_buf;
+		unsigned char *z_wr_buf;
+		unsigned char *z_rd_buf;
 #	endif /* USE_ZLIB */
 		void *tls_ctx;
 };
@@ -110,8 +158,8 @@ char *nntp_server = NULL;
 		static void enable_deflate(struct nntpbuf *nntpbuf);
 #	endif /* USE_ZLIB */
 	static int nntpbuf_refill(struct nntpbuf *buf);
-	static int nntpbuf_flush(struct nntpbuf* buf);
-	static int nntpbuf_puts(const char* data, struct nntpbuf* buf);
+	static int nntpbuf_flush(struct nntpbuf *buf);
+	static int nntpbuf_puts(const char *data, struct nntpbuf *buf);
 	static int nntpbuf_getc(struct nntpbuf *buf);
 	static int nntpbuf_ungetc(int c, struct nntpbuf *buf);
 	static char *nntpbuf_gets(char *s, int size, struct nntpbuf *buf);
@@ -263,7 +311,7 @@ getserverbyfile(
 		return NULL;
 
 	if ((fp = tin_fopen(file, "r")) != NULL) {
-		while (fgets(buf, (int) sizeof(buf), fp) != NULL) {
+		while (fgets(buf, sizeof(buf), fp) != NULL) {
 			if (*buf == '\n' || *buf == '#')
 				continue;
 
@@ -315,7 +363,7 @@ getserverbyfile(
 #ifdef NNTP_ABLE
 static int
 server_init(
-	char *machine,
+	const char *machine,
 	const char *cservice,	/* usually a literal */
 	unsigned short port,
 	char *text,
@@ -377,23 +425,41 @@ server_init(
 #	endif /* NNTPS_ABLE */
 
 	nntp_buf.fd = sock_fd;
+#	ifdef AF_UNSPEC
+	nntp_buf.family = AF_UNSPEC;
+#	endif /* AF_UNSPEC */
+
+	/* set user timeout (if any) after connect()! */
+	set_tcp_user_rxt_timeout(sock_fd, TRUE);
 
-#	if defined(HAVE_GETPEERNAME) || defined(TLI)
 	{
 		struct sockaddr sa;
 		socklen_t sa_len = sizeof(sa);
 
-#	ifdef HAVE_GETPEERNAME
-		if (getpeername(nntp_buf.fd, &sa, &sa_len) == 0)
-#	else
-#		ifdef TLI
-		if (t_getpeername(nntp_buf.fd, &sa, &sa_len) == 0)
-		/* if (getpeerinaddr(nntp_buf.fd, (struct sockaddr_in *)&sa, &sa_len) == 0) */
-#		endif /* TLI */
-#	endif /* HAVE_GETPEERNAME */
+#	if defined(HAVE_GETSOCKOPT) && defined(SO_DOMAIN)
+		if (getsockopt(sock_fd, SOL_SOCKET, SO_DOMAIN, &sa, &sa_len) == 0)
 			nntp_buf.family = sa.sa_family;
+#	endif /* HAVE_GETSOCKOPT && SO_DOMAIN */
+
+#	if defined(HAVE_GETPEERNAME) || defined(TLI)
+#		ifdef AF_UNSPEC
+		if (nntp_buf.family == AF_UNSPEC)
+#		else
+		if (!nntp_buf.family)
+#		endif /* AF_UNSPEC */
+		{
+#		ifdef HAVE_GETPEERNAME
+			if (getpeername(nntp_buf.fd, &sa, &sa_len) == 0)
+#		else
+#			ifdef TLI
+			/* if (t_getpeername(nntp_buf.fd, &sa, &sa_len) == 0) */ /* does t_getpeername() exist? */
+			if (getpeerinaddr(nntp_buf.fd, (struct sockaddr_in *) &sa, &sa_len) == 0) /* DYNIX/ptx */
+#			endif /* TLI */
+#		endif /* HAVE_GETPEERNAME */
+				nntp_buf.family = sa.sa_family;
+		}
+#	endif /* HAVE_GETPEERNAME || TLI */
 	}
-#endif /* HAVE_GETPEERNAME || TLI */
 
 	last_put[0] = '\0';		/* no retries in get_respcode */
 	/*
@@ -623,6 +689,7 @@ get_tcp_socket(
 
 #			if defined(__hpux) && defined(SVR4)	/* recommended by raj@cup.hp.com */
 #				define HPSOCKSIZE 0x8000
+#				if defined(HAVE_GETSOCKOPT) && defined(HAVE_SETSOCKOPT)
 		getsockopt(s, SOL_SOCKET, SO_SNDBUF, /* (caddr_t) */ &socksize, /* (caddr_t) */ &socksizelen);
 		if (socksize < HPSOCKSIZE) {
 			socksize = HPSOCKSIZE;
@@ -635,8 +702,11 @@ get_tcp_socket(
 			socksize = HPSOCKSIZE;
 			setsockopt(s, SOL_SOCKET, SO_RCVBUF, /* (caddr_t) */ &socksize, sizeof(socksize));
 		}
+#				endif /* HAVE_GETSOCKOPT && HAVE_SETSOCKOPT */
 #			endif /* __hpux && SVR4 */
 
+		set_tcp_user_ini_timeout(s, TRUE);
+
 		if ((x = connect(s, (struct sockaddr *) &sock_in, sizeof(sock_in))) == 0)
 			break;
 
@@ -670,6 +740,8 @@ get_tcp_socket(
 		return -1;
 	}
 
+	set_tcp_user_ini_timeout(s, TRUE);
+
 	/* And connect */
 	if (connect(s, (struct sockaddr *) &sock_in) < 0) {
 		save_errno = errno;
@@ -690,6 +762,9 @@ get_tcp_socket(
 #				else
 	memcpy((char *) &sock_in.sin_addr, hp->h_addr, hp->h_length);
 #				endif /* HAVE_HOSTENT_H_ADDR_LIST */
+
+	set_tcp_user_ini_timeout(s, TRUE);
+
 	if (connect(s, (struct sockaddr *) &sock_in, sizeof(sock_in)) < 0) {
 		save_errno = errno;
 		perror("connect");
@@ -700,6 +775,7 @@ get_tcp_socket(
 #			endif /* EXCELAN */
 #		endif /* h_addr */
 #	endif /* TLI */
+
 	return s;
 }
 #endif /* NNTP_ABLE && !INET6 */
@@ -761,6 +837,9 @@ get_tcp6_socket(
 			es = errno;
 			continue;
 		}
+
+		set_tcp_user_ini_timeout(s, TRUE);
+
 		if (connect(s, res->ai_addr, res->ai_addrlen) != 0) {
 			ec = errno;
 			close(s);
@@ -855,7 +934,7 @@ get_dnet_socket(
 
 	return s;
 #	else
-    (void) machine;
+	(void) machine;
 	return -1;
 #	endif /* NNTP_ABLE */
 }
@@ -905,7 +984,7 @@ put_server(
 	t_bool hide_from_log)
 {
 	if (*string) {
-		DEBUG_IO((stderr, "put_server(%s)\n", string));
+		DEBUG_IO((stderr, "%sput_server(\"%s\")\n", logtime(), string));
 		nntpbuf_puts(string, &nntp_buf);
 		nntpbuf_puts("\r\n", &nntp_buf);
 
@@ -949,7 +1028,7 @@ reconnect(
 	int retry)
 {
 	char buf[NNTP_STRLEN];
-	int save_signal_context = signal_context;
+	enum context save_signal_context = signal_context;
 
 	/*
 	 * Tear down current connection
@@ -960,7 +1039,7 @@ reconnect(
 	if (!tinrc.auto_reconnect)
 		ring_bell();
 
-	DEBUG_IO((stderr, _("\nServer timed out, trying reconnect # %d\n"), retry));
+	DEBUG_IO((stderr, "\n%sServer timed out, trying %s reconnect: #%d/%d\n", logtime(), tinrc.auto_reconnect ? "auto" : "ask", retry, NNTP_TRY_RECONNECT));
 
 	/*
 	 * set signal_context temporary to cReconnect to avoid trouble when receiving
@@ -1003,7 +1082,7 @@ reconnect(
 	if (!nntp_open()) {
 		/* Re-establish our current group and resend last command */
 		if (curr_group != NULL) {
-			DEBUG_IO((stderr, _("Rejoin current group\n")));
+			DEBUG_IO((stderr, "%sRejoin current group\n", logtime()));
 			snprintf(last_put, sizeof(last_put), "GROUP %s", curr_group->name);
 			put_server(last_put, FALSE);
 			if (nntpbuf_gets(last_put, NNTP_STRLEN, &nntp_buf) == NULL)
@@ -1012,16 +1091,16 @@ reconnect(
 			if (debug & DEBUG_NNTP)
 				debug_print_file("NNTP", "<<<%s%s", logtime(), last_put);
 #	endif /* DEBUG */
-			DEBUG_IO((stderr, _("Read (%s)\n"), last_put));
+			DEBUG_IO((stderr, "%sreconnect() Read (%s)\n", logtime(), last_put));
 		}
-		DEBUG_IO((stderr, _("Resend last command (%s)\n"), buf));
+		DEBUG_IO((stderr, "%sreconnect() Resend last command (%s)\n", logtime(), buf));
 		put_server(buf, FALSE);
 		did_reconnect = TRUE;
 		retry = NNTP_TRY_RECONNECT;
 	}
 
 #	if defined(HAVE_ALARM) && defined(SIGALRM)
-		alarm(0);
+	alarm(0);
 #	endif /* HAVE_ALARM && SIGALRM */
 
 	return retry;
@@ -1035,12 +1114,12 @@ fgetc_server(
 	int c;
 
 	if (stream != FAKE_NNTP_FP) {
-		DEBUG_IO((stderr, "fgetc_server: BAD fp\n"));
+		DEBUG_IO((stderr, "%sfgetc_server: BAD fp\n", logtime()));
 		return EOF;
 	}
 
 	c = nntpbuf_getc(&nntp_buf);
-	DEBUG_IO((stderr, "fgetc_server: %c / %d\n", c, c));
+	DEBUG_IO((stderr, "%sfgetc_server: %c / %d\n", logtime(), c, c));
 
 	return c;
 }
@@ -1052,11 +1131,11 @@ ungetc_server(
 	FILE *stream)
 {
 	if (stream != FAKE_NNTP_FP) {
-		DEBUG_IO((stderr, "fgetc_server: BAD fp\n"));
+		DEBUG_IO((stderr, "%sfgetc_server: BAD fp\n", logtime()));
 		return EOF;
 	}
 
-	DEBUG_IO((stderr, "ungetc_server: %c / %d\n", c, c));
+	DEBUG_IO((stderr, "%sungetc_server: %c / %d\n", logtime(), c, c));
 
 	return nntpbuf_ungetc(c, &nntp_buf);
 }
@@ -1097,13 +1176,16 @@ get_server(
 	alarm((unsigned) TIN_NNTP_TIMEOUT);
 #	endif /* HAVE_ALARM && SIGALRM */
 	while (!nntpbuf_is_open(&nntp_buf) || nntpbuf_gets(string, size, &nntp_buf) == NULL) {
+#	ifdef EINTR
 		if (errno == EINTR) {
 			errno = 0;
-#	if defined(HAVE_ALARM) && defined(SIGALRM)
+#		if defined(HAVE_ALARM) && defined(SIGALRM)
 			alarm((unsigned) TIN_NNTP_TIMEOUT);		/* Restart the timer */
-#	endif /* HAVE_ALARM && SIGALRM */
+#		endif /* HAVE_ALARM && SIGALRM */
 			continue;
 		}
+#	endif /* EINTR */
+
 #	if defined(HAVE_ALARM) && defined(SIGALRM)
 		alarm(0);
 #	endif /* HAVE_ALARM && SIGALRM */
@@ -1111,7 +1193,11 @@ get_server(
 			tin_done(NNTP_ERROR_EXIT, NULL);		/* And don't try to disconnect again! */
 
 #	ifdef DEBUG
+#		ifdef EINTR
 		if (errno != 0 && errno != EINTR)	/* Will only confuse end users */
+#		else
+		if (errno != 0)
+#		endif /* EINTR */
 			perror_message("get_server()");
 #	endif /* DEBUG */
 
@@ -1167,6 +1253,12 @@ static void
 close_server(
 	t_bool send_no_quit)
 {
+	 /* we want to quit, don't bother to reconnect */
+#if defined(TIMEOUT_INI_NAME) && TIMEOUT_INI_NAME != TIMEOUT_RXT_NAME
+	set_tcp_user_rxt_timeout(nntp_buf.fd, FALSE);
+#endif /* TIMEOUT_INI_NAME && TIMEOUT_INI_NAME != TIMEOUT_RXT_NAME */
+	set_tcp_user_ini_timeout(nntp_buf.fd, FALSE);
+
 	if (!send_no_quit && nntpbuf_is_open(&nntp_buf)) {
 		if ((!batch_mode || verbose) && cCOLS > 1) {
 			char *msg = strunc(_(txt_disconnecting), (size_t) (cCOLS - 1));
@@ -1175,7 +1267,7 @@ close_server(
 			my_fputc('\n', stdout);
 			free(msg);
 		}
-		nntp_command("QUIT", OK_GOODBYE, NULL, 0);
+		new_nntp_command("QUIT", OK_GOODBYE, NULL, 0);
 		quitting = TRUE;										/* Don't reconnect just for this */
 	}
 	nntpbuf_close(&nntp_buf);
@@ -1189,13 +1281,16 @@ close_server(
  * extensions.
  *
  * Sets up: t_capabilities nntp_caps
+ *
+ * NOTE: LIST HEADERS RANGE is checked/setup in art.c:read_overview()
+ * (for Path) and LIST HEADERS MSGID is check in select.c:lookup_msgid()
+ * (for Xref and/or Newsgroups).
  */
 int
 check_extensions(
 	int rvl)
 {
-	char *d;
-	char *ptr;
+	char *d, *s, *ptr;
 	char buf[NNTP_STRLEN];
 	int i;
 	int ret = 0;
@@ -1203,8 +1298,8 @@ check_extensions(
 	static const char *tin_mechs[] = { /* SASL mechanisms our code can handle */
 		"PLAIN",			/* RFC 4616 */
 		"ANONYMOUS",		/* RFC 4505 */
-		"LOGIN",			/* just for testing, remove b4 release */
 #if 0
+		"LOGIN",			/* just for testing, remove b4 release */
 		"EXTERNAL",			/* RFC 4422 */
 		"OTP",				/* RFC 2444 */
 		"SECURID",			/* RFC 2808 */
